QueueClientBuilder Class
Definition
This class provides a fluent builder API to help aid the configuration and instantiation of the QueueClient and QueueAsyncClient, calling buildClient() constructs an instance of QueueClient and calling buildAsyncClient() constructs an instance of QueueAsyncClient.
The client needs the endpoint of the Azure Storage Queue service, name of the queue, and authorization credentials. endpoint(String endpoint) gives the builder the endpoint and may give the builder the queueName(String queueName) and a sasToken(String sasToken) that authorizes the client.
Instantiating a synchronous Queue Client with SAS token
QueueClient client = new QueueClientBuilder()
.endpoint("https://${accountName}.queue.core.windows.net?${SASToken}")
.buildClient();
Instantiating an Asynchronous Queue Client with SAS token
QueueAsyncClient queueAsyncClient = new QueueClientBuilder()
.endpoint("https://{accountName}.queue.core.windows.net?{SASToken}")
.buildAsyncClient();
If the endpoint doesn't contain the queue name or SAS token they may be set using queueName(String queueName) and sasToken(String sasToken).
Instantiating a synchronous Queue Client with credential
QueueClient client = new QueueClientBuilder()
.endpoint("https://${accountName}.queue.core.windows.net")
.queueName("myqueue")
.sasToken("{SASTokenQueryParams}")
.buildClient();
Instantiating an Asynchronous Queue Client with credential
QueueAsyncClient queueAsyncClient = new QueueClientBuilder()
.endpoint("https://{accountName}.queue.core.windows.net")
.queueName("myqueue")
.sasToken("{SASTokenQueryParams}")
.buildAsyncClient();
Another way to authenticate the client is using a StorageSharedKeyCredential. To create a StorageSharedKeyCredential a connection string from the Storage Queue service must be used. Set the StorageSharedKeyCredential with connectionString(String connectionString). If the builder has both a SAS token and StorageSharedKeyCredential the StorageSharedKeyCredential will be preferred when authorizing requests sent to the service.
Instantiating a synchronous Queue Client with connection string.
String connectionString = "DefaultEndpointsProtocol=https;AccountName={name};"
+ "AccountKey={key};EndpointSuffix={core.windows.net}";
QueueClient client = new QueueClientBuilder()
.connectionString(connectionString)
.buildClient();
Instantiating an Asynchronous Queue Client with connection string.
String connectionString = "DefaultEndpointsProtocol=https;AccountName={name};"
+ "AccountKey={key};EndpointSuffix={core.windows.net}";
QueueAsyncClient queueAsyncClient = new QueueClientBuilder()
.connectionString(connectionString)
.buildAsyncClient();
public final class QueueClientBuilder implements TokenCredentialTrait<QueueClientBuilder>, ConnectionStringTrait<QueueClientBuilder>, AzureNamedKeyCredentialTrait<QueueClientBuilder>, AzureSasCredentialTrait<QueueClientBuilder>, HttpTrait<QueueClientBuilder>, ConfigurationTrait<QueueClientBuilder>, EndpointTrait<QueueClientBuilder>
- Inheritance
-
java.lang.ObjectQueueClientBuilder
- Implements
Inherited Members
Constructors
| QueueClientBuilder() |
Creates a builder instance that is able to configure and construct QueueClient and QueueAsyncClient. |
Methods
| addPolicy(HttpPipelinePolicy pipelinePolicy) |
Adds a HttpPipelinePolicy to apply on each request sent. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| buildAsyncClient() |
Creates a QueueAsyncClient based on options set in the builder. Every time If pipeline(HttpPipeline httpPipeline) is set, then the |
| buildClient() |
Creates a QueueClient based on options set in the builder. Every time If pipeline(HttpPipeline httpPipeline) is set, then the |
| clientOptions(ClientOptions clientOptions) |
Allows for setting common properties such as application ID, headers, proxy configuration, etc. Note that it is recommended that this method be called with an instance of the HttpClientOptions class (a subclass of the ClientOptions base class). The HttpClientOptions subclass provides more configuration options suitable for HTTP clients, which is applicable for any class that implements this HttpTrait interface. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| configuration(Configuration configuration) |
Sets the configuration object used to retrieve environment configuration values during building of the client. |
| connectionString(String connectionString) |
Sets the connection string to connect to the service. |
| credential(AzureNamedKeyCredential credential) |
Sets the AzureNamedKeyCredential used to authorize requests sent to the service. |
| credential(AzureSasCredential credential) |
Sets the AzureSasCredential used to authorize requests sent to the service. |
| credential(TokenCredential credential) |
Sets the TokenCredential used to authorize requests sent to the service. Refer to the Azure SDK for Java identity and authentication documentation for more details on proper usage of the TokenCredential type. |
| credential(StorageSharedKeyCredential credential) |
Sets the StorageSharedKeyCredential used to authorize requests sent to the service. |
| endpoint(String endpoint) |
Sets the endpoint for the Azure Storage Queue instance that the client will interact with. The first path segment, if the endpoint contains path segments, will be assumed to be the name of the queue that the client will interact with. Query parameters of the endpoint will be parsed in an attempt to generate a sasToken(String sasToken) to authenticate requests sent to the service. |
| getDefaultHttpLogOptions() |
Gets the default Storage allowlist log headers and query parameters. |
| httpClient(HttpClient httpClient) |
Sets the HttpClient to use for sending and receiving requests to and from the service. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| httpLogOptions(HttpLogOptions logOptions) |
Sets the HttpLogOptions to use when sending and receiving requests to and from the service. If a Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| messageEncoding(QueueMessageEncoding messageEncoding) |
Sets the queue message encoding. |
| pipeline(HttpPipeline httpPipeline) |
Sets the HttpPipeline to use for the service client. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. The endpoint(String endpoint) is not ignored when |
| processMessageDecodingError(Consumer<QueueMessageDecodingError> processMessageDecodingErrorHandler) |
Sets the handler that performs the tasks needed when a message is received or peaked from the queue but cannot be decoded. Such message can be received or peaked when queue is expecting certain QueueMessageEncoding but there's another producer that is not encoding messages in expected way. I.e. the queue contains messages with different encoding. QueueMessageDecodingError contains QueueAsyncClient for the queue that has received the message as well as getQueueMessageItem() or getPeekedMessageItem() with raw body, i.e. no decoding will be attempted so that body can be inspected as has been received from the queue. The handler won't attempt to remove the message from the queue. Therefore such handling should be included into handler itself. Code Samples
|
| processMessageDecodingErrorAsync(Function<QueueMessageDecodingError,Mono<Void>> processMessageDecodingErrorAsyncHandler) |
Sets the asynchronous handler that performs the tasks needed when a message is received or peaked from the queue but cannot be decoded. Such message can be received or peaked when queue is expecting certain QueueMessageEncoding but there's another producer that is not encoding messages in expected way. I.e. the queue contains messages with different encoding. QueueMessageDecodingError contains QueueAsyncClient for the queue that has received the message as well as getQueueMessageItem() or getPeekedMessageItem() with raw body, i.e. no decoding will be attempted so that body can be inspected as has been received from the queue. The handler won't attempt to remove the message from the queue. Therefore such handling should be included into handler itself. Code Samples
|
| queueName(String queueName) |
Sets the name of the queue that the client will interact with. |
| retryOptions(RetryOptions retryOptions) |
Sets the RetryOptions for all the requests made through the client. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. Setting this is mutually exclusive with using retryOptions(RequestRetryOptions retryOptions). Consider using retryOptions(RequestRetryOptions retryOptions) to also set storage specific options. |
| retryOptions(RequestRetryOptions retryOptions) |
Sets the request retry options for all the requests made through the client. Setting this is mutually exclusive with using retryOptions(RetryOptions retryOptions). |
| sasToken(String sasToken) |
Sets the SAS token used to authorize requests sent to the service. |
| serviceVersion(QueueServiceVersion version) |
Sets the QueueServiceVersion that is used when making API requests. If a service version is not provided, the service version that will be used will be the latest known service version based on the version of the client library being used. If no service version is specified, updating to a newer version of the client library will have the result of potentially moving to a newer service version. Targeting a specific service version may also mean that the service will return an error for newer APIs. |